indexing
   title:       "presents an example of TIMESTAMP class usage";
   cluster:     "timedate/examples/test_tst [timedate/examples/test_tst]";
   project:     "The Universal Time & Date UTDC";
   copyright:   "SIG Computer, 1995";
   author:      "Alexei Simonov (alex@eiffel.ru)";
   original:    22,Sep,95;
   version:     1.0;
   done_at:     "SIG Computer (info@eiffel.ru)";
   license:     "GNU Library GPL - see included readme file";
   extrnl_name: "test_tst.e";

class TEST_TIMESTAMP

   inherit
      IO_USER

   creation
      make

   feature

      dd         : DURATION
      ts1, ts2   : TIMESTAMP
      time_tools : TIME_TOOLS


      test_timestamp is

         do
            put_nl ("test TIMESTAMP ----------------")
            !! time_tools;
            !! ts1.set_to_now; -- actual time
            mio.put_string (time_tools.day_name (ts1.day_of_week));
            put_nl (x.s_timestamp (ts1));
            !! dd.set (0, 0, 8, 4, 0, 0);
            -- 8 days + 4 hours in future
            mio.put_string (time_tools.day_name ((ts1 + dd).day_of_week));
            put_nl (x.s_timestamp (ts1 + dd));
            mio.put_string (time_tools.day_name ((ts1 - dd).day_of_week));
            put_nl (x.s_timestamp (ts1 - dd));
            -- 8 days + 4 hours in past
            dd := (ts1 + dd).difference (ts1 - dd);
            put_nl (x.s_duration (dd));
         end -- test_timestamp

      test_2000 is

         do
            -- how many days or seconds until year 2000 ?
            !! ts1.set_to_now;
            mio.put_string (time_tools.day_name (ts1.day_of_week));
            put_nl (x.s_timestamp (ts1));
            !! ts2.set (2000, 1, 1, 0, 0, 0);
            mio.put_string (time_tools.day_name (ts2.day_of_week));
            put_nl (x.s_timestamp (ts2));
            dd := ts2.difference (ts1);
            put_nl (x.s_duration (dd));
            mio.put_real (dd.as_years); put_nl (" as years to year 2000");
            mio.put_real (dd.as_months); put_nl (" as months");
            mio.put_real (dd.as_days); put_nl (" as days");
            mio.put_real (dd.as_hours); put_nl (" as hours");
            mio.put_real (dd.as_minutes); put_nl (" as minutes");
            mio.put_real (dd.as_seconds); put_nl (" as seconds");
         end -- test_2000

      test_date_to_now (yr, mh, dy, hr, me : INTEGER; sd : REAL) is

         do
            !! ts1.set (yr, mh, dy, hr, me, sd);
            !! ts2.set_to_now;
            mio.put_string (time_tools.day_name (ts1.day_of_week));
            put_nl (x.s_timestamp (ts1));
            mio.put_string (time_tools.day_name (ts2.day_of_week));
            put_nl (x.s_timestamp (ts2));
            if ts1 < ts2 then
               dd := ts2.difference (ts1);
            else
               dd := ts1.difference (ts2);
            end -- if

            put_nl (x.s_duration (dd));
            mio.put_real (dd.as_years); put_nl (" as years ");
            mio.put_real (dd.as_months); put_nl (" as months");
            mio.put_real (dd.as_days); put_nl (" as days");
            mio.put_real (dd.as_hours); put_nl (" as hours");
            mio.put_real (dd.as_minutes); put_nl (" as minutes");
            mio.put_real (dd.as_seconds); put_nl (" as seconds");
         end -- test_date_to_now

      make is

         do
            test_timestamp;
            test_2000;
            test_date_to_now (1974, 1, 24, 2, 45, 0.0);
            test_date_to_now (1950, 8, 6, 0, 0, 0.0);
            test_date_to_now (1995, 12, 31, 23, 59, 59.999);
         end -- make

   end --  class TEST_TIMESTAMP

