indexing
   TITLE:       "Simple Timestamp"
   CLUSTER:     "Time & Date - Timespan"
   PROJECT:     "SIG Moscow Cluster library"
   COPYRIGHT:   "SIG Computer Inc, Moscow", 1995
   AUTHOR:      "Alexei Simonov"
   APPROVED_BY: "Frieder Monninger"
   ORIGINAL:    "3,June,95"
   VERSION:     "1.0"
   DONE_AT:     "SIG Computer Inc, Moscow (info@eiffel.ru)"
   LICENSE:     "GNU Library GPL - see included readme file"

deferred class SIMPLE_TIMESTAMP

   inherit
      COMPARABLE
         redefine
            infix "<"
         end

      TIME_SERVER
      -- only necessary as ISE Eiffel redefines is_equal in COMPARABLE    
         undefine
            is_equal
         end

   feature -- commands  

      clear is

         deferred
         end -- clear     

      set_to_now is

         deferred
         end -- set_to_now

   feature -- Queries   

      infix "<" ( ts : like CURRENT ) : BOOLEAN is

         deferred
         end -- infix "<" 

      difference( t : like CURRENT ) : SIMPLE_DURATION is

         deferred
         end -- difference

      infix "+", 
      plus( d : like DIFFERENCE ) :  like CURRENT is

         deferred
         end -- infix "+", plus      

      infix "-", 
      minus( d : like DIFFERENCE ) :  like CURRENT is

         deferred
         end -- infix "-", minus     

   end -- class SIMPLE_TIMESTAMP          
